﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Calculator
{
    /// <summary>
    /// Логика взаимодействия для MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ClassCalculate CC = new ClassCalculate();
        List<string> listSign = new List<string>() { "Выберете функцию", "+", "-", "/", "*", "x^y", "√", "Остаток от деления", "log", "sin", "ctg" };
        public MainWindow()
        {
            InitializeComponent();
            CBSign.ItemsSource = listSign;
            CBSign.SelectedIndex = 0;

        }     
       
        private void BTNCalculate(object sender, RoutedEventArgs e)
        {
            double x1=0, x2=0;
            try
            {
                if (CBSign.SelectedIndex == 9 || CBSign.SelectedIndex == 10)
                {
                    x1 = Convert.ToDouble(TBX1.Text);
                }
                else
                {
                    x1 = Convert.ToDouble(TBX1.Text);
                    x2 = Convert.ToDouble(TBX2.Text);
                }                
            }
            catch
            {
                MessageBox.Show("Неверный формат данных");
                TBAnswer.Text = "";               
            }

            switch (CBSign.SelectedIndex)
            {
                case 0:
                    TBX1.Text = "";
                    TBX2.Text = "";
                    TBAnswer.Text = "";
                    break;
                case 1:                    
                    if (CC.CheckNullTwo(TBX1.Text,TBX2.Text))
                        TBAnswer.Text = CC.Add(x1, x2).ToString();
                    break;
                case 2:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                        TBAnswer.Text = CC.Sub(x1, x2).ToString();
                    break;
                case 3:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                    {
                        if (CC.Div(x1, x2) != 0)
                            TBAnswer.Text = CC.Div(x1, x2).ToString();
                        else
                        {
                            TBAnswer.Text = "";
                            MessageBox.Show("Деление на ноль невозможно");
                        }
                    }
                    break;
                case 4:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                        TBAnswer.Text = CC.Mult(x1, x2).ToString();
                    break;
                case 5:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                        TBAnswer.Text = CC.Exp(x1, x2).ToString();
                    break;
                case 6:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                        TBAnswer.Text = CC.Ext(x1, x2).ToString();
                    break;
                case 7:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                        TBAnswer.Text = CC.Per(x1, x2).ToString();
                    break;
                case 8:
                    if (CC.CheckNullTwo(TBX1.Text, TBX2.Text))
                        TBAnswer.Text = CC.Log(x1, x2).ToString();
                    break;
                case 9:                    
                    if (CC.CheckNullOne(TBX1.Text))
                        TBAnswer.Text = CC.Sin(x1).ToString();
                    break;
                case 10:
                    if (CC.CheckNullOne(TBX1.Text))
                        TBAnswer.Text = CC.Ctg(x1).ToString();
                    break;
                default:
                    break;
            }
        }
        private void SelectionChangedFun(object sender, SelectionChangedEventArgs e)
        {
            switch(CBSign.SelectedIndex)
            {
                case 0:
                    TBX1.IsEnabled = false;
                    TBX2.IsEnabled = false;
                    break;
                case 9:
                case 10:
                    TBX1.IsEnabled = true;
                    TBX2.IsEnabled = false;
                    break;
                default:
                    TBX2.IsEnabled = true;
                    TBX1.IsEnabled = true;
                    break;

            }
        }
        
    }
}
