using System.Windows.Input;
using Calculator;

namespace UnitTests
{
    [TestClass]
    public class UT
    {
        //
        [TestMethod]
        public void AreEqualAdd()
        {
            ClassCalculate CC = new ClassCalculate();
            double x = 5.20;
            Assert.AreEqual(x,CC.Add(3.1,2.1));
        }
        [TestMethod]
        public void AreEqualExt()
        {
            ClassCalculate CC = new ClassCalculate();
            double x = 4;
            Assert.AreEqual(x, CC.Exp(-2,2));
        }
        [TestMethod]
        public void AreNotEqualSub()
        {
            ClassCalculate CC = new ClassCalculate();
            double x = 12.4;
            Assert.AreNotEqual(x, CC.Sub(5.123,2));
        }
        [TestMethod]
        public void AreNotEqualLog()
        {
            ClassCalculate CC = new ClassCalculate();
            double x = 23.015;
            Assert.AreNotEqual(x, CC.Log(5.1, 10));
        }
        [TestMethod]
        public void IsTrueCheckNullOne()
        {
            ClassCalculate CC = new ClassCalculate();
            bool x = true;
            Assert.IsTrue(x== CC.CheckNullOne("Hi"));
        }
        [TestMethod]
        public void IsFalseCheckNullTwo()
        {
            ClassCalculate CC = new ClassCalculate();
            bool x = true;
            Assert.IsTrue(x == CC.CheckNullTwo("","Hi"));
        }
        [TestMethod]
        public void IsInstanceOfTypeDouble()
        {
            ClassCalculate CC = new ClassCalculate();
            double x = CC.Mult(7,1);
            Assert.IsInstanceOfType(x,typeof(double));
        }
        [TestMethod]
        public void IsNotInstanceOfTypeCheckNullTwo()
        {
            ClassCalculate CC = new ClassCalculate();
            bool x = CC.CheckNullTwo(":",")");
            Assert.IsNotInstanceOfType(x, typeof(int));
        }
        [TestMethod]
        public void IsNotNullDiv()
        {
            ClassCalculate CC = new ClassCalculate();
            Assert.IsNotNull(CC.Div(3,0));
        }
        [TestMethod]
        public void IsNotNullPer()
        {
            ClassCalculate CC = new ClassCalculate();
            Assert.IsNotNull(CC.Per(0, 143));
        }

        //
        [TestMethod]
        public void DivideByZeroExceptionDiv()
        {            
            ClassCalculate CC = new ClassCalculate();
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => CC.Div(5,0)));
        }
        [TestMethod]
        public void ArgumentExceptionAdd()
        {
            ClassCalculate CC = new ClassCalculate();
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => CC.Add(5, Convert.ToDouble("Hi"))));
        }
        [TestMethod]
        public void ArgumentNullExceptionMult()
        {
            ClassCalculate CC = new ClassCalculate();
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => CC.Mult(5, Convert.ToDouble(null))));

        }
        [TestMethod]
        public void InvalidCastException()
        {
            ClassCalculate CC = new ClassCalculate();
            bool b = CC.CheckNullOne("Hi");
            int i = 5;
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => b=Convert.ToBoolean(i)));
        }
        [TestMethod]
        public void LongDouble()
        {
            ClassCalculate CC = new ClassCalculate();
            Assert.ThrowsException<AssertFailedException>(() => Assert.ThrowsException<SystemException>(() => CC.Log(Convert.ToDouble(4234234324848423423),10)));
        }

    }
}